/* File scanline.y */
%{

#include	"globali.h"

extern char 	server_name[MAX_BUF];
extern struct   sockaddr_in server_addr;
extern char     *srtt[];

char	*remote_file,*local_file,*p;
struct	hostent *h;

/*host_addr	[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}  versine flex  non funzionano bene con lex*/

%}


skip		[ ]+
intero		[1-9][0-9]*
hostname	[a-zA-Z_][0-9a-zA-Z_\.]*
filename	[a-zA-Z0-9\._]+
host_add	[0-9][0-9]?[0-9]?
host_addr	{host_add}\.{host_add}\.{host_add}\.{host_add}

%%
connect{skip}{hostname}({skip}{intero})? 	{p=strtok(yytext+7," ");
						 strcpy(server_name,p);		/* cerco il nome del server dopo la parola connect*/
						 p = strtok(NULL," "); 	/* se e' specificata l aporta la assegno  	*/
 						 if(p!=NULL)
 						  	 server_addr.sin_port=htons(atoi(p));
 						 h=gethostbyname(server_name);	

						 if(h!=NULL){
						    	server_addr.sin_addr.s_addr=*((u_long*)h->h_addr);						
						 	printf("Le richieste saranno inoltrate a %s.%hd\n",server_name,ntohs(server_addr.sin_port));
						 	}
                                                 else perror("gethostbyname");
						}	
connect{skip}{host_addr}({skip}{intero})?     	{strncpy(server_name,strtok(yytext+7," "),MAX_BUF);	/* cerco l'indirzzo del server dopo la parola connect*/
						 if((p = strtok(NULL," "))!= NULL)
							server_addr.sin_port = htons(atoi(p));
						 printf("Le richieste saranno inoltrate all'indirizzo %s.%hd\n",server_name,ntohs(server_addr.sin_port));
						 server_addr.sin_addr.s_addr=inet_addr(server_name);
						 /*convertire adrr to in_addrgetserverbyaddr*/
						}


get{skip}{filename}({skip}{filename})?       	{if(server_addr.sin_addr.s_addr != INADDR_NONE)/* se ho gia un server con cui comunicare */
						  {
						  remote_file= strtok(yytext+3," ");  /* cerco il nome del file remoto dopo skip */
						  local_file = strtok(NULL," ");      /* cerco il nome del file locale */
						  get(remote_file,local_file,&server_addr);
						  }
                                                 else
						  printf("Occorre prima connettersi ad un server\nuse connect host\n");
						  }	
put{skip}{filename}({skip}{filename})?          {if(server_addr.sin_addr.s_addr != INADDR_NONE)/* se ho gia un server con cui comunicare */
						  {
						  local_file = strtok(yytext+3," ");
						  remote_file=strtok(NULL," ");
						  put(local_file,remote_file,&server_addr);
						  }
                                                   else
    						  printf("Occorre prima connettersi ad un server\nconnect host\n");}	

{skip}						{/*ignora eventuali spazi finali*/}
((mode)?{skip}ascii)|ascii|netascii  		{printf("ascii mode  ON\n");t_mode = netascii;}
((mode)?{skip}binary)|octet|binary		{printf("binary mode ON\n");t_mode = octet;}
rexmt{skip}{intero}          			{printf("Total timeout = %d\n",total_timeout=atoi(strtok(yytext+6," ")));}
status          				{status();}
trace           				{printf("trace ON\n");trace_flag=ON;}
verbose         				{printf("verbose ON\n");verbose_flag=ON;}
("?"\n|help)					{help();}						
quit|exit|(q\n)|(x\n)   			{quit(); return 0;}
ls({skip}[^\n]*)?				{system(yytext);}
rm({skip}[^\n]*)?				{system(yytext);}
cd({skip}[^\n]*)?                           	{system(yytext);chdir(yytext+3);}
sh{skip}[^\n]*					{system(yytext+3);}
predictor					{predictor_type=(predictor_type+1)%3;
						printf("%s\n",srtt[predictor_type]);}
\n						{ready();}
.\n       					{printf("\aSintax error\nhelp or ? for help\n");ready();}
.						{ }

%%


