/* File globali.h */
#ifndef GLOBALI_H
#define	GLOBALI_H

/* occorre almeno una #define ALLOCA tra i files.c  per condividere tra piu files alcune variabili globali*/
#ifdef  ALLOCA		
#define STORAGE
#define INITIALIZE(x) x
#else
#define STORAGE extern
#define INITIALIZE(x)
#endif	

#include "inclusioni.h"

STORAGE int	verbose_flag		INITIALIZE(=OFF);		/* Variabili utente	*/
STORAGE int 	trace_flag		INITIALIZE(=OFF);
STORAGE int 	total_timeout		INITIALIZE(=MAX_RETRY);
STORAGE int 	predictor_type		INITIALIZE(=APPROX_RTT_UPDATE);
STORAGE int 	exponential_bakoff	INITIALIZE(=2);

STORAGE int 	duplicati		INITIALIZE(=0);
STORAGE int 	inviati			INITIALIZE(=0);
STORAGE int 	ricevuti		INITIALIZE(=0);

STORAGE long 	X		INITIALIZE(=0);
STORAGE long 	ACC		INITIALIZE(=0);
STORAGE long 	N		INITIALIZE(=0);
STORAGE double	N_sigma		INITIALIZE(=0);
STORAGE double 	sigma		INITIALIZE(=0);

STORAGE long 	packet_timeout		INITIALIZE(=MAX_TIMER /M);
STORAGE long	timer			INITIALIZE(=MAX_TIMER);
STORAGE long	StanDev			INITIALIZE(=MAX_TIMER);         /* deviazione standard approssimata */
STORAGE long	RTT			INITIALIZE(=0);
STORAGE long	ritardo			INITIALIZE(=0);

STORAGE	int	CTRL_C			INITIALIZE(=OFF);
STORAGE enum    { netascii,octet} t_mode 	INITIALIZE(=octet);	/* modalita' di trasferimento */



#undef STORAGE
#undef INITIALIZE

#endif